<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of XBPlog.
# Copyright (c) 2006 LinkMan. All rights reserved.
#
# XBPlog is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# XBPlog is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Met le formulaire dans un tableau
//form_tab(0) => Laisse tout passer
//form_tab(1) => Laisse rien passer
//form_tab(1, chp1, chp2) => Laisse rien passer sauf chp1 chp2
function form_tab($er = 1){
 if(empty($_POST))return false;
 else $my_tab['form_env'] = 1;
 
 $tab_arg = func_get_args();
 
 foreach($_POST as $key => $value){
  if($value != "")$my_tab[$key] = $value;
  else {
   $ok = 0;  
   foreach($tab_arg as $key_arg => $value_arg)if($key == $value_arg)$ok = 1;
   if($ok == 1){
    $my_tab[$key] = "";
    $ok = 0;
   }
   else {
	if(!isset($tab_er))$tab_er["error_func"] = "error_func";
	$tab_er[] = $key;
   }
  }
 }
 
 if($er == 1 && isset($tab_er))return $tab_er;
 else return $my_tab;
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Fonction pour crer un menu droulant et slctionner automatiquement le bon choix
//Dans le cas o opt est un tableau : Texte, valeur, style
function html_select($name,$opt,$value='',$j_s=''){
 if($j_s)$sel = '<select name="'.$name.'" onChange="'.$j_s.'">';
 else $sel = '<select name="'.$name.'">';
 
 for($i=0;$i<=count($opt)-1;$i++){
  if(is_array($opt[$i])){
   $opt_a = $opt[$i][0];
   
   if($opt[$i][1] || $opt[$i][1] == 0)$opt_v = $opt[$i][1];
   else $opt_v = $opt[$i][0];
   
   if(isset($opt[$i][2]))$opt_s = 'style="'.$opt[$i][2].'"';
   else $opt_s = '';
  }
  else {
   $opt_a = $opt[$i];
   $opt_v = $opt[$i];
   $opt_s = '';
  }   
  
  
  if($value == $opt_v){
   $sel .= '<option '.$opt_s.' value="'.$opt_v.'" selected>'.$opt_a.'</option>';
  }
  else $sel .= '<option '.$opt_s.' value="'.$opt_v.'">'.$opt_a.'</option>';
}
$sel .= '</select>';	

return $sel;
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Renvoi un tableau avec le nom du fichier et son extension
//0 : name file ; 1 : extension
//2 : _1 ; 3 : _2
//4 : nom bloget admin 
function file_ext($file_name){
 $ext = strstr($file_name, ".");
 while(ereg("\.", $ext)){
   $ext = substr($ext, 1);
 }
 
 $file = substr($file_name, 0, strlen($file_name)-strlen($ext)-1);
 
 //Miniatures
 $f_1 = $file."_1.".$ext;
 $f_2 = $file."_2.".$ext;
 //Bloget Admin
 $f_3 = $file."_admin.".$ext;
 
 return array($file, $ext, $f_1, $f_2, $f_3);
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Retourne le lien d'un article avec tableau URL, HTML et BBcode
function antipirate(&$txt){
 if(is_array($txt)){
  foreach($txt as $key => $value){
   $txt[$key] = preg_replace("(<(.+?))",'< $1', $txt[$key]);
  }
  return $txt;
 }
 else return $txt = preg_replace("(<(.+?))",'< $1', $txt);
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Retourne le lien d'un article avec tableau URL, HTML et BBcode
function url_art($id){
 if($id != ''){
	 $req = 'SELECT `id_art`,`id_ss_art`,`titre_art` FROM `'.db_s.'article` WHERE `id_art` = '.$id;
	 $res = mysql_query($req) or die(mysql_error());
	 
	 if(mysql_num_rows($res) == 0)return array('HTML' => 'Pas de rsultat', 'BB' => 'Pas de rsultat');
	 else {
	  $d = mysql_fetch_array($res);
	  if($d['id_ss_art'])return array('URL' => 'art.php?art='.$d['id_art'].'&ss='.$d['id_ss_art'], 'HTML' => '<a href=art.php?art='.$d['id_art'].'&ss='.$d['id_ss_art'].'>'.$d['titre_art'].'</a>', 'BB' => '\[url=art.php?art='.$d['id_art'].'&ss='.$d['id_ss_art'].'\]'.$d['titre_art'].'\[/url]');
	  else return array('URL' => 'art.php?art='.$d['id_art'], 'HTML' => '<a href=art.php?art='.$d['id_art'].'>'.$d['titre_art'].'</a>', 'BB' => '\[url=art.php?art='.$d['id_art'].'\]'.$d['titre_art'].'\[/url]');
	 }
 }
 else return array('URL'=>'Pas de rsultat','HTML' => 'Pas de rsultat', 'BB' => 'Pas de rsultat');
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Pour BBcode : affiche le code php
function bb_php($matches){
 //print_r($matches);
 //if(empty($matches[1]) || $matches[1] == "\r\n")$matches[1] = $matches[2];
 //$matches[1] = html_entity_decode($matches[1]); 
 $php = highlight_string('<?php'.$matches[1].'?>',true);
 return $php;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Pour BBcode : affiche la bonne image
function bb_img($matches){
 if(ereg('/'.ADMIN.'/',$_SERVER['REQUEST_URI']))$dir = '../album/';
 else $dir = 'album/';
 
 $tmp = file_ext($matches[1]);
 
 //if(!ereg("article.php",$_SERVER['REQUEST_URI']))$tmp[2] = $tmp[3];
 
 if($matches[2] == 'center'){
  $align = "";
  $c = array('<center>','</center>');
 }
 else {
  $align = $matches[2];
  $c = array('','');
 }
 
 if(is_file($dir.$tmp[2]))return "$c[0]<a href=\"$dir$matches[1]\" target=_blank><img src=\"$dir$tmp[2]\" align=\"$align\" border=0></a>$c[1]";
 else return "$c[0]<img src=\"$dir$matches[1]\" align=\"$align\">$c[1]";
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Pour BBcode : texte
function bbtohtml(&$article){
 $article = htmlentities($article); 
 
 $article = preg_replace_callback("(\[php\]([[:alnum:][:space:][:punct:][:graph:]]*?)\[\/php])","bb_php",$article);
 
 $article = str_replace("\n", "<br>", $article);
 
 //$article = preg_replace_callback("(\[code\](\r\n)*?(.+?)*?(\r\n)*?\[\/code])","bb_php",$article);
 $article = preg_replace("(\[b\](.+?)\[\/b])",'<b>$1</b>',$article);
 $article = preg_replace("(\[i\](.+?)\[\/i])",'<i>$1</i>',$article);
 $article = preg_replace("(\[u\](.+?)\[\/u])",'<u>$1</u>',$article);
 $article = preg_replace("(\[url\](.+?)\[\/url])",'<a href=$1>$1</a>',$article);
 $article = preg_replace("(\[url=(.+?)\](.+?)\[\/url])",'<a href=$1>$2</a>',$article);
 $article = preg_replace("(\[quote](.+?)\[\/quote])",'<center><table border=1 bordercolor=#DBDBDB bgcolor=white cellspacing=0 cellpadding=5 class=fontblogetV rules="groups" width=80%><tr><td>$1</td></tr></table></center>',$article);
 
 $article = preg_replace("(\[size=([1-9]*)\](.+?)\[\/size])","<span style=\"font-size : $1px\">$2</span>",$article);
 $article = preg_replace("(\[color=(.+?)\](.+?)\[\/color])","<font color=$1>$2</font>",$article);
 
 $article = preg_replace_callback("(\[img src=(.+?) align=(.+?)\])","bb_img",$article);
 
 /////////////
 //Les smileys
 if(ereg('/admin/',$_SERVER['REQUEST_URI']))$dir = '../smilies/';
 else $dir = 'smilies/';
 $req = 'SELECT code_smilies , url_smilies FROM `'.db_s.'smilies`';
 $res = mysql_query($req);
 while($d = mysql_fetch_array($res)){
  $article = str_replace("$d[code_smilies]", ' <img src="'.$dir.$d['url_smilies'].'">', $article);
 }
 /////////////
 
 $article = html_entity_decode($article); 
 $article = str_replace('</span><span style="color: #007700">&</span><span style="color: #0000BB">lt</span><span style="color: #007700">;', '<</span><span style="color: #0000BB">', $article);
 $article = str_replace('</font><font color="#007700">&</font><font color="#0000BB">lt</font><font color="#007700">;', '<</font><font color="#0000BB">', $article);
 $article = str_replace('<?php', '&lt;?php', $article);
 //$article = str_replace(">\r<br><", "><", $article);
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Renvois le mois quand on lui passe un chiffre
function mois($m){
 if(!is_numeric($m) || $m > 12)return false;
 $mois = array("vide","Janvier","Fvrier","Mars","Avril","Mai","Juin","Juillet","Aot","Septembre","Octobre","Novembre","Dcembre");
 if(strlen($m) > 1 && substr($m, 0, 1) == 0)$m = substr($m, 1, 2);
 return $mois[$m];
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Renvois le jour quand lui passe date(n)
function jour($j, $maj = 0){
 if(!is_numeric($j) || $j > 6)return false;
 $jour = array('dimanche','lundi','mardi','mercredi','jeudi','vendredi','samedi');
 //if(strlen($j) > 1 && substr($m, 0, 1) == 0)$m = substr($m, 1, 2);
 if($maj ==1)return ucfirst($jour[$j]);
 else return $jour[$j];
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Echange de valeur ds mysql pr monter/descendre les choses
//$res : resultat de la requte
//$tbl : table; $chp : chp de tri
function echange($res,$tbl,$chp){
    $id1 = mysql_result($res, 0, 0);
    $id2 = mysql_result($res, 1, 0);
	
    $req = "UPDATE $tbl SET `$chp` = 0 WHERE `$chp` = $id1";
    $res = mysql_query($req) or die(mysql_error());
    $req = "UPDATE $tbl SET `$chp` = $id1 WHERE `$chp` = $id2";
    $res = mysql_query($req) or die(mysql_error());
    $req = "UPDATE $tbl SET `$chp` = $id2 WHERE `$chp` = 0";
    $res = mysql_query($req) or die(mysql_error());
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Retourne la config demand 1.1
function xconfig($chp){
 if(is_array($chp)){
  foreach($chp as $value){
  //for($i=0;$i<count($chp);$i++){
   $req = 'SELECT `Value` FROM `'.db_s.'config` WHERE Name = "'.$value.'"';
   $res = mysql_query($req);
   $tab[$value] = mysql_result($res, 0);
  }
  return $tab;
 }
 else {
  $req = 'SELECT `Value` FROM `'.db_s.'config` WHERE Name = "'.$chp.'"';
  $res = mysql_query($req);
  return mysql_result($res, 0);
 }
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Enlve les caractres spciaux
function delspe_char(&$var){
 $from = 
"()[]'~$&%*@!?;,:\^{}|+-<>\"";
 $to	 = 'AAAAAAaaaaaaOOOOOOooooooEEEEeeeeCcIIIIiiiiUUUUuuuuyNn                    
E        ';
 return $var = strtr($var, $from, $to);
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Antispam
function antispam($nick,$msg){
 include('antispam.php');

 while($as = array_shift($antispam_nick)){
  if(eregi($as, $nick))return false;
 }

 while($as = array_shift($antispam_msg)){
  if(eregi($as, $msg))return false;
 }
 
 return true;
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Si $Data est un tableau : 0 / 1 / 2; Size; Color
//
function TabDesign($Data=0,$Img){
 if(!is_array($Data))$Data = array($Data, '100%', '""');
 
 $num = count($Img);
 $keys = array_keys($Img);
 
 $TabDesign_tmp = '';
 for($i=0;$i<$num;$i++){
  $img = getimagesize($Img[$keys[$i]]);
  if(substr($keys[$i], 0, 2) == 'ch'){
   $avt = 'ch';
   $TabDesign_tmp .= '<td '.$img[3].'><img src="'.$Img[$keys[$i]].'" '.$img[3].'></td>';
  }
  else if(substr($keys[$i], 0, 1) == 'm'){
   if(!isset($avt)){
    $TabDesign_tmp .= '</td>';
	$avt = 'm';
   }
   if($avt == 'ch' && $keys[$i] != 'mh'){
     $TabDesign_tmp .= '
		</tr>
		<tr>';
   }
   if($Img[$keys[$i]] != '')$TabDesign_tmp .= '<td '.$img[3].' background='.$Img[$keys[$i]].'></td>';
   else $TabDesign_tmp .= '<td></td>';
   
   if($keys[$i] == 'mg'){
    $TabDesign[] = '
 	<table border=0 width='.$Data[1].' bgcolor='.$Data[2].' cellspacing=0 cellpadding=0>
	<tr>
  '.$TabDesign_tmp.'<td width=100% valign=top>'; 
    $TabDesign_tmp = '';
	unset($avt);
   }
  }
  //----
  else if(substr($keys[$i], 0, 2) == 'cb'){
   if(isset($avt) && $avt == 'm' && $keys[$i-1] != 'mb'){
    $TabDesign_tmp .= '
		</tr>
		<tr>';
   }
   $TabDesign_tmp .= '<td '.$img[3].' background="'.$Img['m'.substr($keys[$i], 2, 3)].'" valign=bottom><img src="'.$Img[$keys[$i]].'" '.$img[3].'></td>';
  }

 }
  
  $TabDesign[] = $TabDesign_tmp.'
   </tr>
   </table>
  ';
 
 return $TabDesign;
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Dcoupe une chaine trop longue
function str_toolong($str,$num=50){
 $tab = preg_split("([[:space:][\\n\\r]]*?)", $str);
 
 $str = '';
 foreach($tab as $value){
  $value = wordwrap($value, $num, '<br>', true);
  $str .= $value.' ';
 }
 $str = substr($str, 0, strlen($str) - 1);
 
 return $str;
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Renvoit la bonne couleure
function ColorAltern($color){
 $color == color1 ? $color = color2 : $color = color1;
 return $color; 
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Renvoit un lment de retour
function Retour($type=1,$value='Retour',$url='history.go(-1)'){
 if($type == 1){
  if($url == 'history.go(-1)')return '<input type=button onclick="'.$url.'" value="'.$value.'">';
  else return '<input type=button onclick="self.location=\''.$url.'\'" value="'.$value.'">';
 }
 else return '<a href="'.$url.'">'.$value.'</a>';
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Gestion des erreurs
function getError(){
 $return = new Exception("Erreur SQL");
 $tbl = $return->getTrace();
 print_r($tbl);
 exit;
}


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Page Index
function Page_Index($page){
 $req = 'SELECT COUNT(`id_art`) FROM '.db_s.'article';
 $res = mysql_query($req);
 $d = mysql_fetch_array($res) or die(getError());  
 $nbr = $d[0];
 $nbr_pg = ceil($nbr / nbr_art);
 DEFINE('nbr_pg',$nbr_pg);//Define car on s'en sert en dessous
 if($page < 1 || $page > $nbr_pg)$page = 1;
 return ($page * nbr_art) - nbr_art;
}


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Bon possesseur d'un doc
function OwnerDoc($id_doc,$doc=0){
 if($_SESSION['level'] == 1)return TRUE;
 if($doc == 'com'){
  $res = mysql_query('SELECT a.nick_art FROM '.db_s.'com c,'.db_s.'article a WHERE c.id_com = '.$id_doc.' AND c.art_com = a.id_art AND a.nick_art = '.$_SESSION['id']) or die(mysql_error());
 }
 else {
  if($doc == 'article')$doc2 = 'art';
  else $doc2 = $doc;
  $res = mysql_query('SELECT nick_'.$doc2.' FROM '.db_s.$doc.' WHERE id_'.$doc2.' = '.$id_doc.' AND nick_'.$doc2.' = '.$_SESSION['id']) or die(mysql_error());
 }
  if(mysql_num_rows($res) > 0 && mysql_result($res, 0) == $_SESSION['id'])return TRUE;
  else return FALSE;
}
?>