function getSelectedText(obj) {
	if (document.selection && document.selection.createRange){
		// Internet Explorer 4.0x
		obj.focus();
		var orig = obj.value.replace(/\r\n/g, "\n"); // IE Bug
		var range = document.selection.createRange();
		
		if (range.parentElement() != obj) {
			return '';
		}
		
		txt = range.text;
		
		return txt;
	} else if (obj.selectionStart >= 0) {
		// FireFox & Safari
		var start = obj.selectionStart;
		var end    = obj.selectionEnd;
		var txt    = obj.value.substr(start, end-start);
		
		return txt;
	} 
	else {
		return '';
	}
}


function insertAtCaret(obj, text) {
	if (document.selection && document.selection.createRange) {
		// Internet Explorer 4.0x
		
		obj.focus();
		var orig = obj.value.replace(/\r\n/g, "\n"); // IE Bug
		var range = document.selection.createRange();

		if(range.parentElement() != obj) {
			return false;
		}

		range.text = text;
		
		var actual = tmp = obj.value.replace(/\r\n/g, "\n");

		for(var diff = 0; diff < orig.length; diff++) {
			if(orig.charAt(diff) != actual.charAt(diff)) break;
		}

		for(var index = 0, start = 0; 
			tmp.match(text) 
				&& (tmp = tmp.replace(text, "")) 
				&& index <= diff; 
			index = start + text.length
		) {
			start = actual.indexOf(text, index);
		}
	} else if (obj.selectionStart >= 0) {
		// FireFox & Safari
		var start = obj.selectionStart;
		var end   = obj.selectionEnd;

		obj.value = obj.value.substr(0, start) 
			+ text 
			+ obj.value.substr(end, obj.value.length);
	}
	
	if (start != null) {
		setCaretTo(obj, start + text.length);
	} else {
		obj.value += text;
	}
}


function ins_bb(theform,sb_code,sb2_code){
 // Get selected text
 var selected_text = getSelectedText(theform);
 
 if(!sb2_code)var sb2_code = sb_code;
 
 if (selected_text == '') {
  // Display prompt if no text is selected
  var inserttext = prompt( 'Entrez le texte  formater'+"\n["+sb_code+"]xxx[/"+sb2_code+"]", '' );
  if ( (inserttext != null) ) {
   insertAtCaret(theform, "["+sb_code+"]"+inserttext+"[/"+sb2_code+"]");
  }
 } 
 else {
  // Insert text automatically around selection
  insertAtCaret(theform, "["+sb_code+"]"+selected_text+"[/"+sb2_code+"]");
 }
 theform.focus();
}


function emoticon(text) {
	var txtarea = document.fart.article;
	text = ' ' + text + ' ';
	if (txtarea.createTextRange && txtarea.caretPos) {
		var caretPos = txtarea.caretPos;
		caretPos.text = caretPos.text.charAt(caretPos.text.length - 1) == ' ' ? caretPos.text + text + ' ' : caretPos.text + text;
		txtarea.focus();
	} else {
		txtarea.value  += text;
		txtarea.focus();
	}
}