<?php
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Redimensionne en regardant quel est le plus grand ct
function redim_img($size,$redim){
 if($size[1] >= $size[0]){
  $width = floor($size[0] * $redim / $size[1]);
  $height = $redim;
 }
 else {
  $height = floor($size[1] * $redim / $size[0]);
  $width = $redim;
 }
 return array($width,$height); 
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
function traitement_img($file,$redim){
 if(!defined('Min_s'))DEFINE('Min_s', 100);
 
 $size = getimagesize($file);
 $f_e = file_ext($file);
 
 if($redim < 100 || $redim > 400) $redim = 400;
 //Premire transformation pour article
 if($size[0] > 400 || $size[1] > 400){
  $size_d = redim_img($size,$redim);
  $ImgC_Color = ImageCreateTrueColor($size_d[0], $size_d[1]);
  
  switch($f_e[1]){
  case 'gif':
   $ImgC_Jpg = ImageCreateFromGif($file);
  break;
  
  case 'png':
   $ImgC_Jpg = ImageCreateFromPng($file);
  break;

  default :
   $ImgC_Jpg = ImageCreateFromJpeg($file);
  }
  
  ImageCopyResampled($ImgC_Color, $ImgC_Jpg, 0, 0, 0, 0, $size_d[0], $size_d[1], $size[0], $size[1]);
  
  switch($f_e[1]){
   case 'gif':
   ImageGif($ImgC_Color, dir_album.$f_e[2]);
   break;
   
   case 'png':
   ImagePng($ImgC_Color, dir_album.$f_e[2]);
   break;
   
   default :
   ImageJpeg($ImgC_Color, dir_album.$f_e[2], 95);
  }
 }
 
 //Deuxime transformation pour miniature
 if($size[0] > Min_s || $size[1] > Min_s)$size_d = redim_img($size,Min_s);
 else $size_d = array($size[0], $size[1]);
  
 $ImgC_Color = ImageCreateTrueColor(Min_s, Min_s);
 
 switch($f_e[1]){
 case 'gif':
  $ImgC_Jpg = ImageCreateFromGif($file);
 break;
 
 case 'png':
 $ImgC_Jpg = ImageCreateFromPng($file);
 break;

 default :
  $ImgC_Jpg = ImageCreateFromJpeg($file);
 }
  
 if($size_d[0] < Min_s){
  $w = (Min_s - $size_d[0]) / 2;
 }
 else $w = 0;
  
 if($size_d[1] < Min_s){
  $h = (Min_s - $size_d[1]) / 2;
 }
 else $h = 0;
  
 ImageCopyResampled($ImgC_Color, $ImgC_Jpg, $w, $h, 0, 0, $size_d[0], $size_d[1], $size[0], $size[1]);
 
 switch($f_e[1]){
 case 'gif':
  ImageGif($ImgC_Color, dir_album.$f_e[3]); 
 break;
 
 case 'png':
  ImagePng($ImgC_Color, dir_album.$f_e[3]);
 break;
 
 default :
  ImageJpeg($ImgC_Color, dir_album.$f_e[3], 85);
 }
}


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//Arguments :
//Envoi du formulaire, Valeur  afficher ds le chp redimension, Commentaire, Valeur de redimension cach pour
//comparaison.
function form_img($self,$redim = 400,$com = '',$hid_redim = 0){
 echo '
  <form action="'.$self.'" method=POST ENCTYPE=multipart/form-data id=fRB>
  <table border=0>
  <tr>
   <td colspan=5>
    <input type=file name=file><br>
	<input type=hidden name=env value=1>
   </td>
  </tr>
  <tr>
   <td colspan=5 class=fontart>Redimensionner (taille en pixels de 100  400) : 
       <input type=text maxlenght=3 size=3 name=redim value='.$redim.'>
   </td>
  </tr>
  <tr>
   <td colspan=5 class=fontart>
    Commentaires de l\'image (facultatif) :<br>
	<textarea cols=50 rows=3 name=com>'.$com.'</textarea></td>
  </tr>
  <tr>
   <td colspan=5 align=right>
	<input type=hidden name=hid_redim value='.$hid_redim.'>
	<input type=submit value=Envoyer id="RB" onClick="javascript:ReplaceButton(\'RB\',\'fRB\')";>
   </td>
  </tr>
  </table>
  </form>
 ';
}


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
function ExtImg($ext){
 switch($ext){
  case 'jpg' : return TRUE; break;
  case 'jpeg' : return TRUE; break;
  case 'gif' : return TRUE; break;
  case 'png' : return TRUE; break;
 
  default:
  return FALSE;
 }
}
?>